function helval_startp()
	return [-1.0; 0.0; 0.0]
end

function helval(x::Array) 

	if x[1] > 0
		return 100.0*(x[3]-5.0*atan(x[2]/x[1])/pi)^2+x[3]^2+100.0*(sqrt(x[2]^2+x[1]^2)-1.0)^2
	elseif x[1] < 0
		return 100.0*(x[3]-10.0*(0.5*atan(x[2]/x[1])/pi+0.5))^2 + x[3]^2+100.0*(sqrt(x[2]^2+x[1]^2)-1.0)^2
	else
		return Inf
	end
end

function helval_grad(x::Array)
	g = zeros(3)
	if x[1] > 0
		g[1] = (x[2]^2+x[1]^2)^((-3.0)/2.0)*(sqrt(x[2]^2+x[1]^2)*((200.0*x[1]*x[2]^2+200.0*x[1]^3)*pi^2+1000.0*x[2]*x[3]*pi
			   -5000.0*x[2]*atan(x[2]/x[1]))+(-200.0*x[1]*x[2]^2-200.0*x[1]^3)*pi^2)/pi^2

		g[2] = (x[2]^2+x[1]^2)^((-3.0)/2.0)*(sqrt(x[2]^2+x[1]^2)*((200.0*x[2]^3+200.0*x[1]^2*x[2])*pi^2-1000.0*x[1]*x[3]*pi
			   +5000.0*x[1]*atan(x[2]/x[1]))+(-200.0*x[2]^3-2000.*x[1]^2*x[2])*pi^2)/pi^2

		g[3] = (202.0*x[3]*pi-1000.0*atan(x[2]/x[1]))/pi
	elseif x[1] < 0
		g[1] = (x[2]^2+x[1]^2)^((-3.0)/2.0)*(sqrt(x[2]^2+x[1]^2)*((200.0*x[1]*x[2]^2+200.*x[1]^3)*pi^2+(1000.*x[2]*x[3]-5000.0*x[2])*pi
			   -5000.0*x[2]*atan(x[2]/x[1]))+(-200.0*x[1]*x[2]^2-200.0*x[1]^3)*pi^2)/pi^2

		g[2] = (x[2]^2+x[1]^2)^((-3.0)/2.0)*(sqrt(x[2]^2+x[1]^2)*((200.0*x[2]^3+200.*x[1]^2*x[2])*pi^2+(5000.*x[1]-1000.0*x[1]*x[3])*pi
			   +5000.0*x[1]*atan(x[2]/x[1]))+(-200.0*x[2]^3-200.0*x[1]^2*x[2])*pi^2)/pi^2

		g[3] = ((202.0*x[3]-1000.0)*pi-1000.*atan(x[2]/x[1]))/pi
	else
	end 

	return g
end
